#include "precompile.h"

#include "buff/batch_add.h"
#include "creature.h"

#include "mt/Buff.h"

void BatchAddBuff::Activate()
{
    std::shared_ptr<Ability> old_context_ability = owner->context_ability;
    glm::vec3 old_context_dir = owner->context_dir;
    Position old_context_pos = owner->context_pos;
    #if 0
    // 999
    owner->context_dir = owner->GetAttackDir();
    owner->context_pos = owner->GetPos();
    #endif

    for (auto& tuple : meta->_batch_add_list) {
        int rand_space = std::get<0>(tuple);
        const auto& items = std::get<1>(tuple);
        if (items.empty()) {
            A8_ABORT();
        }
        int rnd = rand();
        if (rand_space == -1)  {
            //概率
            rnd = rnd % 10000;
            if (rnd < std::get<1>(items[0])){
                const mt::Buff* buff_meta = mt::Buff::GetById(std::get<0>(items[0]));
                if (buff_meta) {
                    #if 0
                    a8::XPrintf("BatchAddBuff:%d %s\n",
                                {
                                    buff_meta->buff_id(),
                                        buff_meta->name()
                                });
                    #endif
                    owner->AddBuff(caster_.Get(), buff_meta, skill_meta, false, nullptr, buff_vars);
                }
            }
        } else {
            //权重
            rnd = rnd % rand_space;
            for (const auto& item : items) {
                if (rnd <= std::get<1>(item)) {
                    const mt::Buff* buff_meta = mt::Buff::GetById(std::get<0>(item));
                    if (buff_meta) {
                        owner->AddBuff(caster_.Get(), buff_meta, skill_meta, false, nullptr, buff_vars);
                    }
                    break;
                }
            }
        }
    }

    owner->context_dir = old_context_dir;
    owner->context_pos = old_context_pos;
    owner->context_ability = old_context_ability;
}

void BatchAddBuff::Deactivate()
{

}
