#pragma once

#include "buff.h"

A8_DECLARE_CLASS_ENUM(BuffCallFunc_e, int,
                      kAddMinorMode = 1,
                      kInternalRangeAddBuff = 3,
                      kDecHp = 4,
                      kMarkTag = 5,
                      kRemoveBuff = 7,
                      kFlashMove = 8,
                      kAddEnergyShield = 10,
                      kAddHp = 11,
                      kFlashMoveToPos = 12,
                      kLightCircle = 13,
                      kSyncProp = 16,
                      kSetBulletBornOffset = 17,
                      kSummonHeroSepcPoint = 18,
                      kSummonHeroSpecDistance = 19,
                      kClearSummonHero = 20,
                      kImmuneAllMove = 21,
                      kDmgForward = 22,
                      kSetGunBuffId = 23,
                      kSummonObstacleSepcPoint = 24,
                      kSummonObstacleSpecDistance = 25,
                      kClearSummonObstacle = 26,
                      kDecSkillCd = 27,
                      kRefreshHp = 28,
                      kAddMaxHp = 29,
                      kSummonCarSpecPoint = 30,
                      kBossAnimi = 31,
                      kAntiHide = 32,
                      kDisableClientSkill = 33,
                      kRangeHoldBuff = 34,
                      kPlayFlyEffect = 35,
                      kLispEval = 36,
                      kSpecCenterRangeHoldBuff = 37,
                      kThrowKnife = 38,
                      kDirectAbsDecHP = 39,
                      kAccumulatePower = 40,
                      kCallShot = 41,
                      kBatchRandomPosSummonObstacle = 42,
                      kOnBreakSkill = 43,
                      kBreakSkill = 44,
                      kBuffEffectCondAdd = 45,
                      kRandAdd = 46,
                      kShowExplosion = 47,
                      kAddArmorShield = 48,
                      kBulletDmgCalcProc = 49,
                      );

class CallFuncBuff : public Buff
{
 public:

    virtual void Activate() override;
    virtual void Deactivate() override;
    virtual void PreExec(const a8::Args* args) override;
    virtual void PostExec(const a8::Args* args) override;

 private:
    void ProcIntervalRangeAddBuffFunc();
    void ProcAddMinorMode();
    void ProcMarkTag();
    void ProcRemoveBuff();
    void ProcFlashMove();
    void ProcAddEnergyShield();
    void ProcAddHp();
    void ProcAddMaxHp();
    void ProcFlashMoveToPos();
    void ProcLightCircle();
    void ProcSyncProp();
    void SummonHeroSpecPoint();
    void SummonHeroSpecDistance();
    void ClearSummonHero();
    void SummonObstacleSpecPoint();
    void SummonObstacleSpecDistance();
    void ClearSummonObstacle();
    void DecSkillCd();
    void SummonCarSpecPoint();
    void RangeHoldBuff();
    void PlayFlyEffect();
    void LispEval();
    void SpecCenterRangeHoldBuff();
    void ThrowKnife();
    void AccumulatePower();
    void Shot();
    void BatchRandomPosSummonObstacle();
    void OnBreakSkill();
    void BreakSkill();
    void BuffEffectCondAdd();
    void RandAdd();
    void ShowExplosion();
    void AddArmorShield();
    void BulletDmgCalcProc();

    void InternalRangeHoldBuff(std::function<bool(glm::vec3&)> get_center_func);

    void OnBreakSkillPreExec();
    void OnBreakSkillPostExec();

    float hold_param2_ = 0.0;
    Weapon* hold_weapon_ = nullptr;
    std::function<void()> deactivate_cb_ = nullptr;
};
