#include "precompile.h"

#include "buff/dive.h"

#include "creature.h"
#include "human.h"
#include "room.h"
#include "stats.h"

#include "mt/Param.h"

void DiveBuff::Activate()
{
    owner->room->xtimer.SetIntervalEx
        (
         SERVER_FRAME_RATE,
         [this] (int event, const a8::Args* args)
         {
             if (a8::TIMER_EXEC_EVENT == event) {
                 if (owner->dead || !owner->IsHuman()) {
                     owner->RemoveBuffByUniId(buff_uniid);
                     return;
                 }
                 Human* hum = owner->AsHuman();
                 if (hum->GetOxygen() > 0) {
                     hum->DecOxygen(mt::Param::s().dive_oxygen_consume);
                     hum->room->frame_event.AddPropChg(hum->GetWeakPtrRef(),
                                                       kPropDive,
                                                       mt::Param::s().dive_oxygen_total,
                                                       hum->GetOxygen(),
                                                       true);
                     return;
                 }
                 float dmg_out = 0.0f;
                 hum->DecHP(mt::Param::s().dive_hp_consume,
                            VP_Water,
                            "water",
                            0,
                            0,
                            "water",
                            dmg_out,
                            0,
                            0);
             }
         },
         &xtimer_attacher
         );
    if (owner->IsHuman()) {
        ++owner->AsHuman()->stats->diving_times;
    }
}

void DiveBuff::Deactivate()
{
    if (owner->IsHuman()) {
        #if 0
        owner->AsHuman()->SetOxygen(0);
        #endif
    }
}
