#include "precompile.h"

#include "buff/in_water.h"

#include "creature.h"
#include "human.h"
#include "room.h"

#include "mt/Param.h"

void InWaterBuff::Activate()
{
    if (owner->IsHuman()) {
        owner->AsHuman()->room->frame_event.AddPropChg
            (owner->AsHuman()->GetWeakPtrRef(),
             kPropDive,
             mt::Param::s().dive_oxygen_total,
             owner->AsHuman()->GetOxygen(),
             true);

        if (owner->IsPlayer()) {
            owner->room->xtimer.SetIntervalEx
                (
                 SERVER_FRAME_RATE,
                 [this] (int event, const a8::Args* args)
                 {
                     if (a8::TIMER_EXEC_EVENT == event) {
                         if (owner->dead || !owner->IsHuman()) {
                             return;
                         }
                         Human* hum = owner->AsHuman();
                         if (!hum->HasBuffEffect(kBET_Dive) &&
                             hum->GetOxygen() < mt::Param::s().dive_oxygen_total) {
                             hum->AddOxygen(mt::Param::s().inwater_oxygen_recover);
                             hum->room->frame_event.AddPropChg
                                 (hum->GetWeakPtrRef(),
                                  kPropDive,
                                  mt::Param::s().dive_oxygen_total,
                                  hum->GetOxygen(),
                                  true);
                             return;
                         }
                     }
                 },
                 &xtimer_attacher
                 );
        }
    }
}

void InWaterBuff::Deactivate()
{
    if (owner->IsHuman()) {
        if (owner->IsPlayer()) {
            Human* hum = owner->AsHuman();
            owner->room->xtimer.SetIntervalEx
                (
                 SERVER_FRAME_RATE,
                 [hum] (int event, const a8::Args* args)
                 {
                     if (a8::TIMER_EXEC_EVENT == event) {
                         if (hum->HasBuffEffect(kBET_InWater) || hum->dead) {
                             hum->room->xtimer.DeleteCurrentTimer();
                             return;
                         }
                         if (hum->GetOxygen() >= mt::Param::s().dive_oxygen_total) {
                             hum->room->xtimer.DeleteCurrentTimer();
                             return;
                         }
                         hum->AddOxygen(mt::Param::s().inwater_oxygen_recover);
                     }
                 },
                 &hum->xtimer_attacher
                 );
        }
    }
}
