#pragma once

A8_DECLARE_ENUM(SpecBuffId_e,
    kThroughWall_BUFFID = 6003,
    FLY_BUFFID = 7001,
    JUMP_BUFFID = 7002,
    DRIVER_BUFFID = 7003,
    PASSENGER_BUFFID = 7004,
    kRecoilBuffId = 7005,
    kInGrassBuffId = 7006,
    kInIceBuffId = 7008,
    kBeRecycleBuffId = 7009,
    kTraceBuffId = 7011,
    kInMountainTopBuffId = 7014,
    kDownBuffId = 7015,
    kPoisioningBuffId = 7016,
    kRescuerBuffId = 7017,
    kVertigoBuffId = 7018,
    kPeaceModeBuffId = 7019,
    kInRescueBuffId = 7020,
    kKeepShotAnimiBuffId = 7021,
    kVertigoEffectBuffId = 7022,
    kDispelEffectBuffId = 7023,
    kImmuneEffectBuffId = 7024,
    kInWater1BuffId = 7026,
    kInWater2BuffId = 7027,
    kInWater3BuffId = 7028,
    kRecoverHpEffectBuffId = 7040,
    kInMagmaBuffId = 7041,
    kPullToWalkableBuffId = 8003,
    kDiveBuffId = 8054,
    kHoldGunBuffId = 8059,
    kInvincibleBuffId = 1005,
);

A8_DECLARE_ENUM(BuffEffectType_e,
    kBET_Begin = 0,
    kBET_SummonLoot = 1,
    kBET_TurnOver = 2, //翻滚
    kBET_Building = 3,
    kBET_Invincible = 4, //无敌
    kBET_Camouflage = 5, //伪装
    kBET_Immune = 6, //免疫
    kBET_CallFunc = 7, //调用功能
    kBET_NewProtect = 8, //新手保护血量低于50%
    kBET_BePull = 9, //拉人(被拉方)
    kBET_DistanceDmgAddition = 10,
    kBET_UnUse11 = 11, //
    kBET_Scale = 12, //缩放角色模型，这时res_scale表示缩放比，客户端需要特殊处理
    kBET_UnUse13 = 13,
    kBET_PlayShotAni = 14, //播放射击动画
    kBET_Vertigo = 15, //眩晕
    kBET_Floating = 16, //浮空
    kBET_PullDone = 17, //拖拽到目的地
    kBET_DelayAddBuff = 18, //延迟加buff
    kBET_ModifyAttr = 19, //修改属性
    kBET_UnUse20 = 20,
    kBET_UnUse21 = 21,
    kBET_UnUse22 = 22,
    kBET_HunLuan = 23, //混乱,在烟雾弹中不自动瞄准
    kBET_Fly = 24, //飞行中
    kBET_Jump = 25, //跳伞中
    kBET_IntervalAddBuff = 26, //循环定时器
    kBET_PhaseAddBuff = 27, //分阶段定时器添加
    kBET_UnUse28 = 28,
    kBET_SummonHero = 29, //召唤英雄
    //kBET_SummonHero = 30, //向前跳跃
    kBET_UnUse31 = 31,
    kBET_Hide = 32, //隐身
    kBET_UnUse33 = 33,
    kBET_UnUse34 = 34,
    kBET_Sprint = 35, //冲刺
    kBET_SummonObstacle = 36, //召唤物件
    kBET_FlashMove = 37, //瞬间移动
    kBET_SelectTargetWithSpecPos = 38, //指定中心范围内选取目标,并且批量添加buff
    kBET_ShotCharge = 39, //射击蓄力
    kBET_SelectTargetWithSelfPos = 40, //已自己坐标为中心范围内选取目标,并且批量添加buff
    kBET_EventAdd = 41, //even添加buff
    kBET_AddInventory = 42, //扩充库存
    kBET_Down = 43, //倒下
    kBET_Poisoning = 44, //中毒（毒圈中）
    kBET_Rescuer = 45, //救人中(救人方)
    kBET_AddCarBuff = 46, //给载具加buff
    kBET_RemoveCarBuff = 47, //移除载具身上的buff
    kBET_BulletThrough = 48, //穿透

    kBET_FollowMaster = 49, //跟随主人
    kBET_ThroughWall = 50, //穿墙
    kBET_Driver = 51, //驾驶中
    kBET_Passenger = 52, //乘座中
    kBET_CarActive = 53, //激活载具
    kBET_CarDeactive = 54, //载具待机
    kBET_Recoil = 55, //后坐力
    kBET_InGrass = 56, //在草丛
    kBET_InWater = 57, //在水里
    kBET_InIce = 58, //在冰里
    kBET_PullToWalkable = 59, //从碰撞里以自己方向拖出来直到没有碰撞
    kBET_BatchAddBuff = 60, //批量添加buff
    kBET_BeRecycle = 61, //待回收
    kBET_Trace = 62, //追踪玩家
    kBET_MountainTop = 63, //在山顶
    kBET_UseSkill = 64, //使用技能
    kBET_CamouflageAddition = 65, //对抗伪装
    kBET_AutoShot = 66, //自动射击
    kBET_BeatBack = 67, //击退
    kBET_Disperse = 68, //驱散
    kBET_PeaceMode = 69, //和平模式
    kBET_InMagma = 70, //在岩浆里
    kBET_CondAdd = 71, //
    kBET_Dive = 72, //下潜模式
    kBET_Reverse = 73, //人物反向
    kBET_HoldGun = 74, //持枪状态
    kBET_MachineGun = 75, //机枪
    kBET_HoldShield = 76, //手持盾牌
    kBET_InRescue = 77, //被救援中(被就方)

    kBET_End
);

enum EntityType_e
{
   ET_None = 0,
   ET_Player = 1,
   ET_Obstacle = 2,
   ET_Building = 3,
   //ET_LootSpawner = 4,
   ET_Loot = 5,
   //ET_DeadBody = 6,
   //ET_Decal = 7,
   //ET_Projectile = 8,
   //ET_Smoke = 9,
   ET_Hero = 10,
   ET_Car = 11,

   ET_Bullet = 20,

   ET_MapBlock = 28,
   ET_Dummy = 29,
   ET_Unuse = 30,
   ET_MAX
};
