#pragma once

namespace cs
{
    class SMUpdate;
    class SMUiUpdate;
}

class Human;
class Room;
class FrameData;
class FrameMaker
{
 public:

    std::shared_ptr<cs::SMUpdate> MakeUpdateMsg(Human* hum);

private:
    void Debug_FullObject(Human* hum);
    void Debug_OutObject(Human* hum);

    void PreProcess(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void PostProcess(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeLootObjects(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeNewObjects(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeImageObjects(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializePartObjects(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeDelObjects(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeOutObjects(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeShots(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeEmotes(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeBullets(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializePlaySkills(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeExplosions(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedBuffs(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedEffects(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedBulletNums(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedHps(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedSkillCds(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedSkillCurrTimes(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedItems(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedWeaponAmmo(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeDeadAliveObjs(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedCars(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeChgedProps(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeDelBullets(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
    void SerializeVoices(cs::SMUpdate* msg, Room* room, Human* hum, FrameData* framedata);
};
