#pragma once

class GlmHelper
{
 public:
    static const glm::vec3 ZERO;
    static const glm::vec3 LEFT;
    static const glm::vec3 RIGHT;
    static const glm::vec3 UP;
    static const glm::vec3 DONW;

    static void RotateY(glm::vec3& v, float angle);
    static void Normalize(glm::vec3& v);
    static float Norm(const glm::vec3& v);
    static float Norm2D(const glm::vec3& v);
    static bool IsZero(const glm::vec3& v);
    static bool IsValidVec3(const glm::vec3& v);

    static bool IsEqual2D(const glm::vec3& v1, const glm::vec3& v2);
    static bool IsEqual3D(const glm::vec3& v1, const glm::vec3& v2);

    static float CalcAngle(const glm::vec3& v1, const glm::vec3& v2);

    static void FillVert(const glm::vec3& v, float* vert);
    static glm::vec3 Vec2ToVec3(const glm::vec2& v2);
};
