#pragma once

#include "creature.h"

#include "weakptr.h"

class Human;
class Room;
class HeroAI;
class Creature;
class HeroAgent;
class Hero : public Creature
{
public:
    const mt::Hero* meta = nullptr;
    bool is_pve_boss = false;
    list_head entry;
    glm::vec3 src_pos = glm::vec3(0.0f, 0.0f, 0.0f);

    Hero();
    virtual ~Hero() override;
    virtual void Initialize() override;
    virtual void FillMFObjectPart(Room* room, Human* hum, cs::MFObjectPart* part_data) override;
    virtual void FillMFObjectFull(Room* room, Human* hum, cs::MFObjectFull* full_data) override;
    virtual void OnExplosionHit(Explosion* e) override;
    virtual void OnBulletHit(IBullet* bullet) override;
    virtual void Update(int delta_time) override;
    virtual void DecHP(float dec_hp,
                       int killer_id, const std::string killer_name, int weapon_id,
                       int real_killer_id, const std::string real_killer_name,
                       float& real_dmg_out,
                       int dmg_type,
                       int dmg_bp) override;
    virtual std::string GetName() override;
    virtual void DropItems(Obstacle* obstacle) override;
    virtual const mt::Hero* GetHeroMeta() override { return meta; };
    virtual float GetRadius() override;
    virtual float GetHitRadius() override;
    virtual void OnAddToTargetPartObject(Entity* target) override;
    virtual void OnRemoveFromTargetPartObject(Entity* target) override;
    virtual void OnBattleStart(Room* room) override;
    virtual void DoSkillPostProc(bool used, int skill_id, int target_id) override;
    void Destory();
    void BeKill(int killer_id, const std::string& killer_name, int weapon_id);
    void Active();
    void Deactive();

protected:
    virtual void UpdateMove() override;
    void InitAI();
    void DetachFromMaster();

private:
    bool later_removed_ = false;
    bool detached_ = false;
    HeroAgent* agent_ = nullptr;

    friend class HeroAI;
    friend class PBUtils;
};
