#pragma once

#include "mt/macro.h"
#include "mtb/Hero.h"

namespace mt
{

    class BattleBasicAttribute;

    const int SHOT_HAND_RIGHT = 0;
    const int SHOT_HAND_LEFT = 1;

    struct HeroShotAnimationOther
    {
        int hand = 0;
        int t = 0;
        float x = 0.0f;
        float y = 0.0f;
        float z = 0.0f;
    };

    struct HeroShotAnimation
    {
        int id = 0;
        int t = 0;
        int is_other = 0;

        float r_x = 0;
        float r_y = 0;
        float r_z = 0;

        float l_x = 0;
        float l_y = 0;
        float l_z = 0;

        float p3_x = 0;
        float p3_y = 0;
        float p3_z = 0;

        float p4_x = 0;
        float p4_y = 0;
        float p4_z = 0;

        float p5_x = 0;
        float p5_y = 0;
        float p5_z = 0;

        std::vector<HeroShotAnimationOther> other_list;
        int GetShotAnimTime(int bullet_idx) const;
        int GetShotHand(int bullet_idx) const;
    };

    DECLARE_ID_TABLE(Hero, mtb::Hero,
                     "hero@hero.json",
                     "id")
    public:

        std::array<int, IS_END> _volume = {};
        std::vector<int> _init_buffs;
        std::vector<std::tuple<int, int>> _dead_drop;
        std::vector<std::tuple<int, int>> _pre_appear_effect;
        bool HasDrop() const { return !_dead_drop.empty();};
        std::tuple<int, int> _pve_score;
        std::map<int, HeroShotAnimation> shot_animations;
        std::map<int, HeroShotAnimation> other_shot_animations;
        std::vector<int> _drop_list;
        std::vector<int> _other_keys;

        void Init1();
        static void StaticPostInit();

        int RandDrop() const;
        const HeroShotAnimation* GetShotAnimi(int shotfire) const;
        float GetHeight() const { return height_; }
        const mt::BattleBasicAttribute* GetBasicMeta() const { return basic_meta_; }

    private:
        float height_ = 0.0f;
        const mt::BattleBasicAttribute* basic_meta_ = nullptr;

        static void LoadHeroAndEquipShotData();
    };

}
