#include "precompile.h"

#include "mt/MobaRoom.h"
#include "mt/MetaMgr.h"

IMPL_TABLE(mt::MobaRoom)

namespace mt
{

    void MobaRoom::Init1()
    {
        {
            std::vector<std::string> strings;
            a8::Split(towers(), strings, '|');
            if (strings.size() != 2) {
                abort();
            }
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                if (strings2.size() != 4) {
                    abort();
                }
                glm::vec3 center = glm::vec3((float)a8::XValue(strings2[0]).GetDouble(),
                                             (float)a8::XValue(strings2[1]).GetDouble(),
                                             (float)a8::XValue(strings2[2]).GetDouble());
                float radius = (float)a8::XValue(strings2[3]).GetDouble();
                moba_towers.push_back(std::make_tuple(center, radius));
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(monster_revive(), strings, '|');
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                if (strings2.size() != 3) {
                    abort();
                }
                monster_revive_[a8::XValue(strings2[0])] = std::make_tuple
                    (
                     a8::XValue(strings2[1]).GetInt(),
                     a8::XValue(strings2[2]).GetInt());
            }
        }
        {
            std::vector<std::string> strings;
            a8::Split(batterys(), strings, '|');
            if (strings.size() != 2) {
                abort();
            }
            for (auto& str : strings) {
                std::vector<std::string> strings2;
                a8::Split(str, strings2, ':');
                if (strings2.size() != 5) {
                    abort();
                }
                glm::vec3 center = glm::vec3((float)a8::XValue(strings2[0]).GetDouble(),
                                             (float)a8::XValue(strings2[1]).GetDouble(),
                                             (float)a8::XValue(strings2[2]).GetDouble());
                float radius = (float)a8::XValue(strings2[3]).GetDouble();
                int equip_id = a8::XValue(strings2[4]);
                moba_batterys.push_back(std::make_tuple(center, radius, equip_id));
            }
        }
    }

    void MobaRoom::Init2()
    {
    }

    int MobaRoom::GetMonsterReviveTime(int hero_id) const
    {
        auto itr = monster_revive_.find(hero_id);
        return itr != monster_revive_.end() ? std::get<0>(itr->second) : -1;
    }

    int MobaRoom::GetMonsterLootLifeTime(int hero_id) const
    {
        auto itr = monster_revive_.find(hero_id);
        return itr != monster_revive_.end() ? std::get<1>(itr->second) : -1;
    }

}
