#include "precompile.h"

#include "mt/SafeAreaSafePoint.h"

IMPL_TABLE(mt::SafeAreaSafePoint)

std::map<int, std::vector<glm::vec3>> mt::SafeAreaSafePoint::_type_safe_points_hash;

namespace mt
{

    void SafeAreaSafePoint::Init1()
    {
        auto itr = _type_safe_points_hash.find(type());
        if (itr == _type_safe_points_hash.end()) {
            _type_safe_points_hash[type()] = std::vector<glm::vec3>();
            itr = _type_safe_points_hash.find(type());
        }
        itr->second.push_back(glm::vec3(x(), y(), z()));
    }

    void SafeAreaSafePoint::StaticPostInit()
    {
    }

    glm::vec3* SafeAreaSafePoint::RandPoint(int type)
    {
        auto itr = _type_safe_points_hash.find(type);
        return itr != _type_safe_points_hash.end() && !itr->second.empty() ?
            &itr->second.at(rand() % itr->second.size()) : nullptr;
    }

}
