#pragma once

#include <bitset>

namespace mtb
{

  class AI
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int pursuit_radius() const { return pursuit_radius_; };
    int attack_interval() const { return attack_interval_; };
    int attack_times() const { return attack_times_; };
    int attack_type() const { return attack_type_; };
    int shot_offset_angle() const { return shot_offset_angle_; };
    const std::string random_move_idle_time() const { return random_move_idle_time_; };
    const std::string random_move_time() const { return random_move_time_; };
    int attack_range() const { return attack_range_; };
    float attack_rate() const { return attack_rate_; };
    int ai_mode() const { return ai_mode_; };
    int ai_kind() const { return ai_kind_; };
    const std::string param1() const { return param1_; };
    const std::string param2() const { return param2_; };
    const std::string param3() const { return param3_; };
    const std::string param4() const { return param4_; };
    const std::string param5() const { return param5_; };
    int peace_time() const { return peace_time_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_pursuit_radius() const { return __flags__.test(1);};
    bool has_attack_interval() const { return __flags__.test(2);};
    bool has_attack_times() const { return __flags__.test(3);};
    bool has_attack_type() const { return __flags__.test(4);};
    bool has_shot_offset_angle() const { return __flags__.test(5);};
    bool has_random_move_idle_time() const { return __flags__.test(6);};
    bool has_random_move_time() const { return __flags__.test(7);};
    bool has_attack_range() const { return __flags__.test(8);};
    bool has_attack_rate() const { return __flags__.test(9);};
    bool has_ai_mode() const { return __flags__.test(10);};
    bool has_ai_kind() const { return __flags__.test(11);};
    bool has_param1() const { return __flags__.test(12);};
    bool has_param2() const { return __flags__.test(13);};
    bool has_param3() const { return __flags__.test(14);};
    bool has_param4() const { return __flags__.test(15);};
    bool has_param5() const { return __flags__.test(16);};
    bool has_peace_time() const { return __flags__.test(17);};

  protected:

    int id_ = 0;
    int pursuit_radius_ = 0;
    int attack_interval_ = 0;
    int attack_times_ = 0;
    int attack_type_ = 0;
    int shot_offset_angle_ = 0;
    std::string random_move_idle_time_;
    std::string random_move_time_;
    int attack_range_ = 0;
    float attack_rate_ = 0.0f;
    int ai_mode_ = 0;
    int ai_kind_ = 0;
    std::string param1_;
    std::string param2_;
    std::string param3_;
    std::string param4_;
    std::string param5_;
    int peace_time_ = 0;

public:
    std::bitset<18> __flags__;
  };

};
