#pragma once

#include <bitset>

namespace mtb
{

  class AirLine
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    const std::string start_point() const { return start_point_; };
    const std::string end_point() const { return end_point_; };
    float plane_speed() const { return plane_speed_; };
    int weight() const { return weight_; };
    int map_id() const { return map_id_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_start_point() const { return __flags__.test(1);};
    bool has_end_point() const { return __flags__.test(2);};
    bool has_plane_speed() const { return __flags__.test(3);};
    bool has_weight() const { return __flags__.test(4);};
    bool has_map_id() const { return __flags__.test(5);};

  protected:

    int id_ = 0;
    std::string start_point_;
    std::string end_point_;
    float plane_speed_ = 0.0f;
    int weight_ = 0;
    int map_id_ = 0;

public:
    std::bitset<6> __flags__;
  };

};
