#pragma once

#include <bitset>

namespace mtb
{

  class AirRaid
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int time() const { return time_; };
    int appear_time() const { return appear_time_; };
    const std::string bomb_id() const { return bomb_id_; };
    const std::string raid_wave() const { return raid_wave_; };
    float rad() const { return rad_; };
    const std::string bombling_time() const { return bombling_time_; };
    float damage() const { return damage_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_time() const { return __flags__.test(1);};
    bool has_appear_time() const { return __flags__.test(2);};
    bool has_bomb_id() const { return __flags__.test(3);};
    bool has_raid_wave() const { return __flags__.test(4);};
    bool has_rad() const { return __flags__.test(5);};
    bool has_bombling_time() const { return __flags__.test(6);};
    bool has_damage() const { return __flags__.test(7);};

  protected:

    int id_ = 0;
    int time_ = 0;
    int appear_time_ = 0;
    std::string bomb_id_;
    std::string raid_wave_;
    float rad_ = 0.0f;
    std::string bombling_time_;
    float damage_ = 0.0f;

public:
    std::bitset<8> __flags__;
  };

};
