#pragma once

#include <bitset>

namespace mtb
{

  class BattleBasicAttribute
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    float pBaseHealth() const { return pBaseHealth_; };
    float pOrigHealth() const { return pOrigHealth_; };
    float vOrigHealth() const { return vOrigHealth_; };
    float pBaseAttack() const { return pBaseAttack_; };
    float pOrigAttack() const { return pOrigAttack_; };
    float vOrigAttack() const { return vOrigAttack_; };
    float pBaseDefend() const { return pBaseDefend_; };
    float pOrigDefend() const { return pOrigDefend_; };
    float vOrigDefend() const { return vOrigDefend_; };
    float pBaseBlock() const { return pBaseBlock_; };
    float pOrigBlock() const { return pOrigBlock_; };
    float vOrigBlock() const { return vOrigBlock_; };
    float vOrigEvaDef() const { return vOrigEvaDef_; };
    float pBaseCrit() const { return pBaseCrit_; };
    float pOrigCrit() const { return pOrigCrit_; };
    float vOrigCrit() const { return vOrigCrit_; };
    float vOrigCriBon() const { return vOrigCriBon_; };
    float vOrigDamageTakenRateIn() const { return vOrigDamageTakenRateIn_; };
    float vOrigDamageDealtRateIn() const { return vOrigDamageDealtRateIn_; };
    float vOrigNormalDamageTakenRateIn() const { return vOrigNormalDamageTakenRateIn_; };
    float vOrigNormalDamageDealtRateIn() const { return vOrigNormalDamageDealtRateIn_; };
    float vOrigSkillDamageTakenRateIn() const { return vOrigSkillDamageTakenRateIn_; };
    float vOrigSkillDamageDealtRateIn() const { return vOrigSkillDamageDealtRateIn_; };
    float vOrigHealthGainRateIn() const { return vOrigHealthGainRateIn_; };
    float vOrigHealDealtRateIn() const { return vOrigHealDealtRateIn_; };
    float vOrigSpeed() const { return vOrigSpeed_; };
    float vOrigHaste() const { return vOrigHaste_; };
    float vOrigDrain() const { return vOrigDrain_; };
    float vOrigTenacity() const { return vOrigTenacity_; };
    float vOrigBloDef() const { return vOrigBloDef_; };
    const std::string battleGrowRule() const { return battleGrowRule_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_pBaseHealth() const { return __flags__.test(1);};
    bool has_pOrigHealth() const { return __flags__.test(2);};
    bool has_vOrigHealth() const { return __flags__.test(3);};
    bool has_pBaseAttack() const { return __flags__.test(4);};
    bool has_pOrigAttack() const { return __flags__.test(5);};
    bool has_vOrigAttack() const { return __flags__.test(6);};
    bool has_pBaseDefend() const { return __flags__.test(7);};
    bool has_pOrigDefend() const { return __flags__.test(8);};
    bool has_vOrigDefend() const { return __flags__.test(9);};
    bool has_pBaseBlock() const { return __flags__.test(10);};
    bool has_pOrigBlock() const { return __flags__.test(11);};
    bool has_vOrigBlock() const { return __flags__.test(12);};
    bool has_vOrigEvaDef() const { return __flags__.test(13);};
    bool has_pBaseCrit() const { return __flags__.test(14);};
    bool has_pOrigCrit() const { return __flags__.test(15);};
    bool has_vOrigCrit() const { return __flags__.test(16);};
    bool has_vOrigCriBon() const { return __flags__.test(17);};
    bool has_vOrigDamageTakenRateIn() const { return __flags__.test(18);};
    bool has_vOrigDamageDealtRateIn() const { return __flags__.test(19);};
    bool has_vOrigNormalDamageTakenRateIn() const { return __flags__.test(20);};
    bool has_vOrigNormalDamageDealtRateIn() const { return __flags__.test(21);};
    bool has_vOrigSkillDamageTakenRateIn() const { return __flags__.test(22);};
    bool has_vOrigSkillDamageDealtRateIn() const { return __flags__.test(23);};
    bool has_vOrigHealthGainRateIn() const { return __flags__.test(24);};
    bool has_vOrigHealDealtRateIn() const { return __flags__.test(25);};
    bool has_vOrigSpeed() const { return __flags__.test(26);};
    bool has_vOrigHaste() const { return __flags__.test(27);};
    bool has_vOrigDrain() const { return __flags__.test(28);};
    bool has_vOrigTenacity() const { return __flags__.test(29);};
    bool has_vOrigBloDef() const { return __flags__.test(30);};
    bool has_battleGrowRule() const { return __flags__.test(31);};

  protected:

    int id_ = 0;
    float pBaseHealth_ = 0.0f;
    float pOrigHealth_ = 0.0f;
    float vOrigHealth_ = 0.0f;
    float pBaseAttack_ = 0.0f;
    float pOrigAttack_ = 0.0f;
    float vOrigAttack_ = 0.0f;
    float pBaseDefend_ = 0.0f;
    float pOrigDefend_ = 0.0f;
    float vOrigDefend_ = 0.0f;
    float pBaseBlock_ = 0.0f;
    float pOrigBlock_ = 0.0f;
    float vOrigBlock_ = 0.0f;
    float vOrigEvaDef_ = 0.0f;
    float pBaseCrit_ = 0.0f;
    float pOrigCrit_ = 0.0f;
    float vOrigCrit_ = 0.0f;
    float vOrigCriBon_ = 0.0f;
    float vOrigDamageTakenRateIn_ = 0.0f;
    float vOrigDamageDealtRateIn_ = 0.0f;
    float vOrigNormalDamageTakenRateIn_ = 0.0f;
    float vOrigNormalDamageDealtRateIn_ = 0.0f;
    float vOrigSkillDamageTakenRateIn_ = 0.0f;
    float vOrigSkillDamageDealtRateIn_ = 0.0f;
    float vOrigHealthGainRateIn_ = 0.0f;
    float vOrigHealDealtRateIn_ = 0.0f;
    float vOrigSpeed_ = 0.0f;
    float vOrigHaste_ = 0.0f;
    float vOrigDrain_ = 0.0f;
    float vOrigTenacity_ = 0.0f;
    float vOrigBloDef_ = 0.0f;
    std::string battleGrowRule_;

public:
    std::bitset<32> __flags__;
  };

};
