#pragma once

#include <bitset>

namespace mtb
{

  class Equip
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int equip_type() const { return equip_type_; };
    int equip_subtype() const { return equip_subtype_; };
    int equip_lv() const { return equip_lv_; };
    int fire_mode() const { return fire_mode_; };
    int use_bullet() const { return use_bullet_; };
    int clip_volume() const { return clip_volume_; };
    int reload_time() const { return reload_time_; };
    int fire_rate() const { return fire_rate_; };
    const std::string atk() const { return atk_; };
    int def() const { return def_; };
    const std::string max_hp() const { return max_hp_; };
    int explosion_range() const { return explosion_range_; };
    int bullet_speed() const { return bullet_speed_; };
    int range() const { return range_; };
    int use_time() const { return use_time_; };
    const std::string heal() const { return heal_; };
    int time() const { return time_; };
    const std::string volume() const { return volume_; };
    int bullet_rad() const { return bullet_rad_; };
    int group_num() const { return group_num_; };
    int is_luck() const { return is_luck_; };
    const std::string bullet_born_offset() const { return bullet_born_offset_; };
    float bullet_angle() const { return bullet_angle_; };
    const std::string name() const { return name_; };
    float rad() const { return rad_; };
    float rad2() const { return rad2_; };
    int buffid() const { return buffid_; };
    int drop_id() const { return drop_id_; };
    int explosion_effect() const { return explosion_effect_; };
    const std::string param1() const { return param1_; };
    const std::string param2() const { return param2_; };
    int reloadtype() const { return reloadtype_; };
    float recoil_force() const { return recoil_force_; };
    int missiles_time() const { return missiles_time_; };
    int heroid() const { return heroid_; };
    const std::string launch_dev() const { return launch_dev_; };
    const std::string power_time() const { return power_time_; };
    const std::string power_gun() const { return power_gun_; };
    const std::string power_buff() const { return power_buff_; };
    int through_teammate() const { return through_teammate_; };
    const std::string text_icon() const { return text_icon_; };
    const std::string special_damage_type() const { return special_damage_type_; };
    float max_oil() const { return max_oil_; };
    float average_oil() const { return average_oil_; };
    float atk_mech() const { return atk_mech_; };
    int use_scene() const { return use_scene_; };
    int ispenetrate() const { return ispenetrate_; };
    int is_penetrate_thing() const { return is_penetrate_thing_; };
    int reload_delay_time() const { return reload_delay_time_; };
    int cast_time() const { return cast_time_; };
    int aiming_cast_time() const { return aiming_cast_time_; };
    int auto_switch_weapon_time() const { return auto_switch_weapon_time_; };
    int quality() const { return quality_; };
    int explosion_damage_delay() const { return explosion_damage_delay_; };
    int bullet_consume_type() const { return bullet_consume_type_; };
    const std::string inventory_slot() const { return inventory_slot_; };
    int _inventory_slot() const { return _inventory_slot_; };
    float critical() const { return critical_; };
    float cri_damage() const { return cri_damage_; };
    int shootfire() const { return shootfire_; };
    const std::string hit_buff() const { return hit_buff_; };
    int auto_trace() const { return auto_trace_; };
    int trace_range() const { return trace_range_; };
    int double_gun() const { return double_gun_; };
    int hand() const { return hand_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_equip_type() const { return __flags__.test(1);};
    bool has_equip_subtype() const { return __flags__.test(2);};
    bool has_equip_lv() const { return __flags__.test(3);};
    bool has_fire_mode() const { return __flags__.test(4);};
    bool has_use_bullet() const { return __flags__.test(5);};
    bool has_clip_volume() const { return __flags__.test(6);};
    bool has_reload_time() const { return __flags__.test(7);};
    bool has_fire_rate() const { return __flags__.test(8);};
    bool has_atk() const { return __flags__.test(9);};
    bool has_def() const { return __flags__.test(10);};
    bool has_max_hp() const { return __flags__.test(11);};
    bool has_explosion_range() const { return __flags__.test(12);};
    bool has_bullet_speed() const { return __flags__.test(13);};
    bool has_range() const { return __flags__.test(14);};
    bool has_use_time() const { return __flags__.test(15);};
    bool has_heal() const { return __flags__.test(16);};
    bool has_time() const { return __flags__.test(17);};
    bool has_volume() const { return __flags__.test(18);};
    bool has_bullet_rad() const { return __flags__.test(19);};
    bool has_group_num() const { return __flags__.test(20);};
    bool has_is_luck() const { return __flags__.test(21);};
    bool has_bullet_born_offset() const { return __flags__.test(22);};
    bool has_bullet_angle() const { return __flags__.test(23);};
    bool has_name() const { return __flags__.test(24);};
    bool has_rad() const { return __flags__.test(25);};
    bool has_rad2() const { return __flags__.test(26);};
    bool has_buffid() const { return __flags__.test(27);};
    bool has_drop_id() const { return __flags__.test(28);};
    bool has_explosion_effect() const { return __flags__.test(29);};
    bool has_param1() const { return __flags__.test(30);};
    bool has_param2() const { return __flags__.test(31);};
    bool has_reloadtype() const { return __flags__.test(32);};
    bool has_recoil_force() const { return __flags__.test(33);};
    bool has_missiles_time() const { return __flags__.test(34);};
    bool has_heroid() const { return __flags__.test(35);};
    bool has_launch_dev() const { return __flags__.test(36);};
    bool has_power_time() const { return __flags__.test(37);};
    bool has_power_gun() const { return __flags__.test(38);};
    bool has_power_buff() const { return __flags__.test(39);};
    bool has_through_teammate() const { return __flags__.test(40);};
    bool has_text_icon() const { return __flags__.test(41);};
    bool has_special_damage_type() const { return __flags__.test(42);};
    bool has_max_oil() const { return __flags__.test(43);};
    bool has_average_oil() const { return __flags__.test(44);};
    bool has_atk_mech() const { return __flags__.test(45);};
    bool has_use_scene() const { return __flags__.test(46);};
    bool has_ispenetrate() const { return __flags__.test(47);};
    bool has_is_penetrate_thing() const { return __flags__.test(48);};
    bool has_reload_delay_time() const { return __flags__.test(49);};
    bool has_cast_time() const { return __flags__.test(50);};
    bool has_aiming_cast_time() const { return __flags__.test(51);};
    bool has_auto_switch_weapon_time() const { return __flags__.test(52);};
    bool has_quality() const { return __flags__.test(53);};
    bool has_explosion_damage_delay() const { return __flags__.test(54);};
    bool has_bullet_consume_type() const { return __flags__.test(55);};
    bool has_inventory_slot() const { return __flags__.test(56);};
    bool has__inventory_slot() const { return __flags__.test(57);};
    bool has_critical() const { return __flags__.test(58);};
    bool has_cri_damage() const { return __flags__.test(59);};
    bool has_shootfire() const { return __flags__.test(60);};
    bool has_hit_buff() const { return __flags__.test(61);};
    bool has_auto_trace() const { return __flags__.test(62);};
    bool has_trace_range() const { return __flags__.test(63);};
    bool has_double_gun() const { return __flags__.test(64);};
    bool has_hand() const { return __flags__.test(65);};

  protected:

    int id_ = 0;
    int equip_type_ = 0;
    int equip_subtype_ = 0;
    int equip_lv_ = 0;
    int fire_mode_ = 0;
    int use_bullet_ = 0;
    int clip_volume_ = 0;
    int reload_time_ = 0;
    int fire_rate_ = 0;
    std::string atk_;
    int def_ = 0;
    std::string max_hp_;
    int explosion_range_ = 0;
    int bullet_speed_ = 0;
    int range_ = 0;
    int use_time_ = 0;
    std::string heal_;
    int time_ = 0;
    std::string volume_;
    int bullet_rad_ = 0;
    int group_num_ = 0;
    int is_luck_ = 0;
    std::string bullet_born_offset_;
    float bullet_angle_ = 0.0f;
    std::string name_;
    float rad_ = 0.0f;
    float rad2_ = 0.0f;
    int buffid_ = 0;
    int drop_id_ = 0;
    int explosion_effect_ = 0;
    std::string param1_;
    std::string param2_;
    int reloadtype_ = 0;
    float recoil_force_ = 0.0f;
    int missiles_time_ = 0;
    int heroid_ = 0;
    std::string launch_dev_;
    std::string power_time_;
    std::string power_gun_;
    std::string power_buff_;
    int through_teammate_ = 0;
    std::string text_icon_;
    std::string special_damage_type_;
    float max_oil_ = 0.0f;
    float average_oil_ = 0.0f;
    float atk_mech_ = 0.0f;
    int use_scene_ = 0;
    int ispenetrate_ = 0;
    int is_penetrate_thing_ = 0;
    int reload_delay_time_ = 0;
    int cast_time_ = 0;
    int aiming_cast_time_ = 0;
    int auto_switch_weapon_time_ = 0;
    int quality_ = 0;
    int explosion_damage_delay_ = 0;
    int bullet_consume_type_ = 0;
    std::string inventory_slot_;
    int _inventory_slot_ = 0;
    float critical_ = 0.0f;
    float cri_damage_ = 0.0f;
    int shootfire_ = 0;
    std::string hit_buff_;
    int auto_trace_ = 0;
    int trace_range_ = 0;
    int double_gun_ = 0;
    int hand_ = 0;

public:
    std::bitset<66> __flags__;
  };

};
