#pragma once

#include <bitset>

namespace mtb
{

  class FormulaPvp
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    float top() const { return top_; };
    float ranked_topx() const { return ranked_topx_; };
    float kills_topx() const { return kills_topx_; };
    float hero_topx() const { return hero_topx_; };
    float weapon_topx() const { return weapon_topx_; };
    float survival_topx() const { return survival_topx_; };

    bool has_top() const { return __flags__.test(0);};
    bool has_ranked_topx() const { return __flags__.test(1);};
    bool has_kills_topx() const { return __flags__.test(2);};
    bool has_hero_topx() const { return __flags__.test(3);};
    bool has_weapon_topx() const { return __flags__.test(4);};
    bool has_survival_topx() const { return __flags__.test(5);};

  protected:

    float top_ = 0.0f;
    float ranked_topx_ = 0.0f;
    float kills_topx_ = 0.0f;
    float hero_topx_ = 0.0f;
    float weapon_topx_ = 0.0f;
    float survival_topx_ = 0.0f;

public:
    std::bitset<6> __flags__;
  };

};
