#pragma once

#include <bitset>

namespace mtb
{

  class Hero
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    float radius() const { return radius_; };
    float move_speed() const { return move_speed_; };
    float jump_speed() const { return jump_speed_; };
    float fall_speed() const { return fall_speed_; };
    float aim_speed() const { return aim_speed_; };
    float shoot_speed() const { return shoot_speed_; };
    float reload_speed() const { return reload_speed_; };
    float medicine_speed() const { return medicine_speed_; };
    float swim_speed() const { return swim_speed_; };
    const std::string volume() const { return volume_; };
    int level() const { return level_; };
    int race() const { return race_; };
    const std::string name() const { return name_; };
    float hit_offset_x() const { return hit_offset_x_; };
    float hit_offset_y() const { return hit_offset_y_; };
    float hit_radius() const { return hit_radius_; };
    const std::string ai_script() const { return ai_script_; };
    const std::string init_buffs() const { return init_buffs_; };
    int default_weapon() const { return default_weapon_; };
    const std::string dead_drop() const { return dead_drop_; };
    int delay_delete() const { return delay_delete_; };
    int ai() const { return ai_; };
    int delay_remove() const { return delay_remove_; };
    int skinlist() const { return skinlist_; };
    const std::string pre_appear_effect() const { return pre_appear_effect_; };
    const std::string pve_score() const { return pve_score_; };
    int hp() const { return hp_; };
    int damage() const { return damage_; };
    int defence() const { return defence_; };
    float crit_atk() const { return crit_atk_; };
    float crit_atk_ratio() const { return crit_atk_ratio_; };
    float miss() const { return miss_; };
    float miss_damage_ruduce() const { return miss_damage_ruduce_; };
    int skill1list() const { return skill1list_; };
    int skill2list() const { return skill2list_; };
    int skill3list() const { return skill3list_; };
    float hp_ratio() const { return hp_ratio_; };
    float damage_ratio() const { return damage_ratio_; };
    float defence_ratio() const { return defence_ratio_; };
    const std::string bt() const { return bt_; };
    const std::string drop() const { return drop_; };
    const std::string new_bt() const { return new_bt_; };
    const std::string other_key_time() const { return other_key_time_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_radius() const { return __flags__.test(1);};
    bool has_move_speed() const { return __flags__.test(2);};
    bool has_jump_speed() const { return __flags__.test(3);};
    bool has_fall_speed() const { return __flags__.test(4);};
    bool has_aim_speed() const { return __flags__.test(5);};
    bool has_shoot_speed() const { return __flags__.test(6);};
    bool has_reload_speed() const { return __flags__.test(7);};
    bool has_medicine_speed() const { return __flags__.test(8);};
    bool has_swim_speed() const { return __flags__.test(9);};
    bool has_volume() const { return __flags__.test(10);};
    bool has_level() const { return __flags__.test(11);};
    bool has_race() const { return __flags__.test(12);};
    bool has_name() const { return __flags__.test(13);};
    bool has_hit_offset_x() const { return __flags__.test(14);};
    bool has_hit_offset_y() const { return __flags__.test(15);};
    bool has_hit_radius() const { return __flags__.test(16);};
    bool has_ai_script() const { return __flags__.test(17);};
    bool has_init_buffs() const { return __flags__.test(18);};
    bool has_default_weapon() const { return __flags__.test(19);};
    bool has_dead_drop() const { return __flags__.test(20);};
    bool has_delay_delete() const { return __flags__.test(21);};
    bool has_ai() const { return __flags__.test(22);};
    bool has_delay_remove() const { return __flags__.test(23);};
    bool has_skinlist() const { return __flags__.test(24);};
    bool has_pre_appear_effect() const { return __flags__.test(25);};
    bool has_pve_score() const { return __flags__.test(26);};
    bool has_hp() const { return __flags__.test(27);};
    bool has_damage() const { return __flags__.test(28);};
    bool has_defence() const { return __flags__.test(29);};
    bool has_crit_atk() const { return __flags__.test(30);};
    bool has_crit_atk_ratio() const { return __flags__.test(31);};
    bool has_miss() const { return __flags__.test(32);};
    bool has_miss_damage_ruduce() const { return __flags__.test(33);};
    bool has_skill1list() const { return __flags__.test(34);};
    bool has_skill2list() const { return __flags__.test(35);};
    bool has_skill3list() const { return __flags__.test(36);};
    bool has_hp_ratio() const { return __flags__.test(37);};
    bool has_damage_ratio() const { return __flags__.test(38);};
    bool has_defence_ratio() const { return __flags__.test(39);};
    bool has_bt() const { return __flags__.test(40);};
    bool has_drop() const { return __flags__.test(41);};
    bool has_new_bt() const { return __flags__.test(42);};
    bool has_other_key_time() const { return __flags__.test(43);};

  protected:

    int id_ = 0;
    float radius_ = 0.0f;
    float move_speed_ = 0.0f;
    float jump_speed_ = 0.0f;
    float fall_speed_ = 0.0f;
    float aim_speed_ = 0.0f;
    float shoot_speed_ = 0.0f;
    float reload_speed_ = 0.0f;
    float medicine_speed_ = 0.0f;
    float swim_speed_ = 0.0f;
    std::string volume_;
    int level_ = 0;
    int race_ = 0;
    std::string name_;
    float hit_offset_x_ = 0.0f;
    float hit_offset_y_ = 0.0f;
    float hit_radius_ = 0.0f;
    std::string ai_script_;
    std::string init_buffs_;
    int default_weapon_ = 0;
    std::string dead_drop_;
    int delay_delete_ = 0;
    int ai_ = 0;
    int delay_remove_ = 0;
    int skinlist_ = 0;
    std::string pre_appear_effect_;
    std::string pve_score_;
    int hp_ = 0;
    int damage_ = 0;
    int defence_ = 0;
    float crit_atk_ = 0.0f;
    float crit_atk_ratio_ = 0.0f;
    float miss_ = 0.0f;
    float miss_damage_ruduce_ = 0.0f;
    int skill1list_ = 0;
    int skill2list_ = 0;
    int skill3list_ = 0;
    float hp_ratio_ = 0.0f;
    float damage_ratio_ = 0.0f;
    float defence_ratio_ = 0.0f;
    std::string bt_;
    std::string drop_;
    std::string new_bt_;
    std::string other_key_time_;

public:
    std::bitset<44> __flags__;
  };

};
