#pragma once

#include <bitset>

namespace mtb
{

  class Item
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int type() const { return type_; };
    int sub_type() const { return sub_type_; };
    int quality() const { return quality_; };
    int use() const { return use_; };
    int skinid() const { return skinid_; };
    int isdefaultskin() const { return isdefaultskin_; };
    int playerid() const { return playerid_; };
    int relationship() const { return relationship_; };
    const std::string name() const { return name_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_type() const { return __flags__.test(1);};
    bool has_sub_type() const { return __flags__.test(2);};
    bool has_quality() const { return __flags__.test(3);};
    bool has_use() const { return __flags__.test(4);};
    bool has_skinid() const { return __flags__.test(5);};
    bool has_isdefaultskin() const { return __flags__.test(6);};
    bool has_playerid() const { return __flags__.test(7);};
    bool has_relationship() const { return __flags__.test(8);};
    bool has_name() const { return __flags__.test(9);};

  protected:

    int id_ = 0;
    int type_ = 0;
    int sub_type_ = 0;
    int quality_ = 0;
    int use_ = 0;
    int skinid_ = 0;
    int isdefaultskin_ = 0;
    int playerid_ = 0;
    int relationship_ = 0;
    std::string name_;

public:
    std::bitset<10> __flags__;
  };

};
