#pragma once

#include <bitset>

namespace mtb
{

  class MapArea
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int map_id() const { return map_id_; };
    int area_type() const { return area_type_; };
    int area_subtype() const { return area_subtype_; };
    const std::string area_center() const { return area_center_; };
    float area_width() const { return area_width_; };
    float area_height() const { return area_height_; };

    bool has_map_id() const { return __flags__.test(0);};
    bool has_area_type() const { return __flags__.test(1);};
    bool has_area_subtype() const { return __flags__.test(2);};
    bool has_area_center() const { return __flags__.test(3);};
    bool has_area_width() const { return __flags__.test(4);};
    bool has_area_height() const { return __flags__.test(5);};

  protected:

    int map_id_ = 0;
    int area_type_ = 0;
    int area_subtype_ = 0;
    std::string area_center_;
    float area_width_ = 0.0f;
    float area_height_ = 0.0f;

public:
    std::bitset<6> __flags__;
  };

};
