#pragma once

#include <bitset>

namespace mtb
{

  class MapMode
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int mode() const { return mode_; };
    int mapMode() const { return mapMode_; };
    int is_open() const { return is_open_; };
    const std::string map_list() const { return map_list_; };
    int level_require() const { return level_require_; };
    int parameter1() const { return parameter1_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_mode() const { return __flags__.test(1);};
    bool has_mapMode() const { return __flags__.test(2);};
    bool has_is_open() const { return __flags__.test(3);};
    bool has_map_list() const { return __flags__.test(4);};
    bool has_level_require() const { return __flags__.test(5);};
    bool has_parameter1() const { return __flags__.test(6);};

  protected:

    int id_ = 0;
    int mode_ = 0;
    int mapMode_ = 0;
    int is_open_ = 0;
    std::string map_list_;
    int level_require_ = 0;
    int parameter1_ = 0;

public:
    std::bitset<7> __flags__;
  };

};
