#pragma once

#include <bitset>

namespace mtb
{

  class PveGemini
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int gemini_id() const { return gemini_id_; };
    int gemini_lv() const { return gemini_lv_; };
    int gemini_limit() const { return gemini_limit_; };
    const std::string multiplayer_enemy_hp_mul() const { return multiplayer_enemy_hp_mul_; };
    const std::string born_point() const { return born_point_; };

    bool has_gemini_id() const { return __flags__.test(0);};
    bool has_gemini_lv() const { return __flags__.test(1);};
    bool has_gemini_limit() const { return __flags__.test(2);};
    bool has_multiplayer_enemy_hp_mul() const { return __flags__.test(3);};
    bool has_born_point() const { return __flags__.test(4);};

  protected:

    int gemini_id_ = 0;
    int gemini_lv_ = 0;
    int gemini_limit_ = 0;
    std::string multiplayer_enemy_hp_mul_;
    std::string born_point_;

public:
    std::bitset<5> __flags__;
  };

};
