#pragma once

#include <bitset>

namespace mtb
{

  class PveGeminiMode
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int map_id() const { return map_id_; };
    const std::string mode_time() const { return mode_time_; };
    const std::string area() const { return area_; };
    const std::string score_reward() const { return score_reward_; };
    const std::string round_score() const { return round_score_; };
    const std::string next_door() const { return next_door_; };
    int wave_prepare_time() const { return wave_prepare_time_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_map_id() const { return __flags__.test(1);};
    bool has_mode_time() const { return __flags__.test(2);};
    bool has_area() const { return __flags__.test(3);};
    bool has_score_reward() const { return __flags__.test(4);};
    bool has_round_score() const { return __flags__.test(5);};
    bool has_next_door() const { return __flags__.test(6);};
    bool has_wave_prepare_time() const { return __flags__.test(7);};

  protected:

    int id_ = 0;
    int map_id_ = 0;
    std::string mode_time_;
    std::string area_;
    std::string score_reward_;
    std::string round_score_;
    std::string next_door_;
    int wave_prepare_time_ = 0;

public:
    std::bitset<8> __flags__;
  };

};
