#pragma once

#include <bitset>

namespace mtb
{

  class SafeArea
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int level() const { return level_; };
    int rad() const { return rad_; };
    int wait_time() const { return wait_time_; };
    int shrink_speed() const { return shrink_speed_; };
    float hurt() const { return hurt_; };
    int type() const { return type_; };
    int x1() const { return x1_; };
    int y1() const { return y1_; };
    const std::string boss() const { return boss_; };
    int rebirth() const { return rebirth_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_level() const { return __flags__.test(1);};
    bool has_rad() const { return __flags__.test(2);};
    bool has_wait_time() const { return __flags__.test(3);};
    bool has_shrink_speed() const { return __flags__.test(4);};
    bool has_hurt() const { return __flags__.test(5);};
    bool has_type() const { return __flags__.test(6);};
    bool has_x1() const { return __flags__.test(7);};
    bool has_y1() const { return __flags__.test(8);};
    bool has_boss() const { return __flags__.test(9);};
    bool has_rebirth() const { return __flags__.test(10);};

  protected:

    int id_ = 0;
    int level_ = 0;
    int rad_ = 0;
    int wait_time_ = 0;
    int shrink_speed_ = 0;
    float hurt_ = 0.0f;
    int type_ = 0;
    int x1_ = 0;
    int y1_ = 0;
    std::string boss_;
    int rebirth_ = 0;

public:
    std::bitset<11> __flags__;
  };

};
