#pragma once

#include <bitset>

namespace mtb
{

  class SafeAreaSafePoint
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int id() const { return id_; };
    int type() const { return type_; };
    float x() const { return x_; };
    float y() const { return y_; };
    float z() const { return z_; };

    bool has_id() const { return __flags__.test(0);};
    bool has_type() const { return __flags__.test(1);};
    bool has_x() const { return __flags__.test(2);};
    bool has_y() const { return __flags__.test(3);};
    bool has_z() const { return __flags__.test(4);};

  protected:

    int id_ = 0;
    int type_ = 0;
    float x_ = 0.0f;
    float y_ = 0.0f;
    float z_ = 0.0f;

public:
    std::bitset<5> __flags__;
  };

};
