#pragma once

#include <bitset>

namespace mtb
{

  class SkillNumber
  {
  public:

    std::shared_ptr<a8::reflect::Class> GetClass() const;
    int skill_id() const { return skill_id_; };
    int skill_type() const { return skill_type_; };
    float number() const { return number_; };
    float damage() const { return damage_; };
    float damage_addition() const { return damage_addition_; };
    float damage_change() const { return damage_change_; };
    float shield() const { return shield_; };
    float shield_addition() const { return shield_addition_; };
    float resume() const { return resume_; };
    float resume_addition() const { return resume_addition_; };
    const std::string speed() const { return speed_; };
    const std::string range() const { return range_; };
    const std::string range2() const { return range2_; };
    const std::string range3() const { return range3_; };
    const std::string range4() const { return range4_; };
    const std::string range5() const { return range5_; };
    const std::string range6() const { return range6_; };
    const std::string time() const { return time_; };
    const std::string cd() const { return cd_; };
    int buff_id() const { return buff_id_; };
    float buff_time() const { return buff_time_; };
    const std::string probability() const { return probability_; };
    int explosion_effect() const { return explosion_effect_; };
    const std::string effect_list() const { return effect_list_; };
    const std::string time2() const { return time2_; };
    const std::string time3() const { return time3_; };
    const std::string time4() const { return time4_; };
    const std::string time5() const { return time5_; };
    const std::string time6() const { return time6_; };

    bool has_skill_id() const { return __flags__.test(0);};
    bool has_skill_type() const { return __flags__.test(1);};
    bool has_number() const { return __flags__.test(2);};
    bool has_damage() const { return __flags__.test(3);};
    bool has_damage_addition() const { return __flags__.test(4);};
    bool has_damage_change() const { return __flags__.test(5);};
    bool has_shield() const { return __flags__.test(6);};
    bool has_shield_addition() const { return __flags__.test(7);};
    bool has_resume() const { return __flags__.test(8);};
    bool has_resume_addition() const { return __flags__.test(9);};
    bool has_speed() const { return __flags__.test(10);};
    bool has_range() const { return __flags__.test(11);};
    bool has_range2() const { return __flags__.test(12);};
    bool has_range3() const { return __flags__.test(13);};
    bool has_range4() const { return __flags__.test(14);};
    bool has_range5() const { return __flags__.test(15);};
    bool has_range6() const { return __flags__.test(16);};
    bool has_time() const { return __flags__.test(17);};
    bool has_cd() const { return __flags__.test(18);};
    bool has_buff_id() const { return __flags__.test(19);};
    bool has_buff_time() const { return __flags__.test(20);};
    bool has_probability() const { return __flags__.test(21);};
    bool has_explosion_effect() const { return __flags__.test(22);};
    bool has_effect_list() const { return __flags__.test(23);};
    bool has_time2() const { return __flags__.test(24);};
    bool has_time3() const { return __flags__.test(25);};
    bool has_time4() const { return __flags__.test(26);};
    bool has_time5() const { return __flags__.test(27);};
    bool has_time6() const { return __flags__.test(28);};

  protected:

    int skill_id_ = 0;
    int skill_type_ = 0;
    float number_ = 0.0f;
    float damage_ = 0.0f;
    float damage_addition_ = 0.0f;
    float damage_change_ = 0.0f;
    float shield_ = 0.0f;
    float shield_addition_ = 0.0f;
    float resume_ = 0.0f;
    float resume_addition_ = 0.0f;
    std::string speed_;
    std::string range_;
    std::string range2_;
    std::string range3_;
    std::string range4_;
    std::string range5_;
    std::string range6_;
    std::string time_;
    std::string cd_;
    int buff_id_ = 0;
    float buff_time_ = 0.0f;
    std::string probability_;
    int explosion_effect_ = 0;
    std::string effect_list_;
    std::string time2_;
    std::string time3_;
    std::string time4_;
    std::string time5_;
    std::string time6_;

public:
    std::bitset<29> __flags__;
  };

};
