#pragma once

#include <a8/singleton.h>

namespace cs
{
    class CMJoin;
}

namespace ss
{
    class SS_WSP_SocketDisconnect;
    class SS_Ping;
}

class Player;
class CustomMember;
class PlayerMgr : public a8::Singleton<PlayerMgr>
{
 public:
    enum { HID = HID_PlayerMgr };

 private:
    PlayerMgr() {};
    friend class a8::Singleton<PlayerMgr>;

 public:
    void Init();
    void UnInit();

    void _SS_Ping(f8::MsgHdr* hdr, const ss::SS_Ping& msg);

    int OnlineNum();
    Player* GetPlayerBySocket(int socket);
    Player* CreatePlayerByCustomMember(Player* hum,
                                       std::shared_ptr<CustomMember> member);
    size_t GetAccountNum() { return account_num_hash_.size(); }
    void IncAccountNum(const std::string& account_id);
    void DecAccountNum(const std::string& account_id);
    void ReBindSocket(Player* hum);
    void RemovePlayerBySocket(int socket_handle);
    void OnGateDisconnect(int gg_socket);
    void OnClientDisconnect(int socket_handle);

 private:
    std::map<int, Player*> socket_hash_;
    std::map<std::string, int> account_num_hash_;
};
