#include "precompile.h"

#include "sandtable.h"
#include "room.h"

#include "mt/Param.h"

SandTable::SandTable(Room* room): room_(room)
{
    if (room->IsSandTableRoom()) {
        room->OpenRoomSwitch(kRoomSwitchDisableUseSkill);
        room->OpenRoomSwitch(kRoomSwitchDisableUseItem);
        room->OpenRoomSwitch(kRoomSwitchDisableShot);
    } else {
        room->OpenRoomSwitch(kRoomSwitchDisableUseSkill);
        room->OpenRoomSwitch(kRoomSwitchDisableUseItem);
    }
#ifdef MYDEBUG
    int lock_time = std::max(0, (int)room->GetGasInactiveTime() - 4);
#else
    int lock_time = std::max(0, (int)room->GetGasInactiveTime() - 10);
#endif
    room->xtimer.SetTimeoutEx
        (SERVER_FRAME_RATE * lock_time,
         [room = room] (int event, const a8::Args* args)
         {
             if (a8::TIMER_EXEC_EVENT == event) {
                 room->LockRoom();
                 #if 0
                 room->CombineTeam();
                 room->FillTeam();
                 #endif
             }
         },
         &room->xtimer_attacher_);
}

void SandTable::OnGameStart()
{
    room_->OpenRoomSwitch(kRoomSwitchDisableMove);
    room_->OpenRoomSwitch(kRoomSwitchDisableUseSkill);
    room_->OpenRoomSwitch(kRoomSwitchDisableUseItem);
    room_->OpenRoomSwitch(kRoomSwitchDisableShot);
    room_->xtimer.SetTimeoutEx
        (SERVER_FRAME_RATE * mt::Param::s().wait_cloud_time,
         [room = room_] (int event, const a8::Args* args)
         {
             if (a8::TIMER_EXEC_EVENT == event) {
                 room->CloseRoomSwitch(kRoomSwitchDisableMove);
                 room->CloseRoomSwitch(kRoomSwitchDisableUseSkill);
                 room->CloseRoomSwitch(kRoomSwitchDisableUseItem);
                 room->CloseRoomSwitch(kRoomSwitchDisableShot);
             }
         },
         &room_->xtimer_attacher_);
}
