#include "precompile.h"

#include "typeconvert.h"
#include "cs_proto.pb.h"
#include "human.h"
#include "stats.h"

namespace TypeConvert
{

    void ToPb(const Position v, cs::MFVec3* pb_obj)
    {
        pb_obj->set_x(v.GetX());
        pb_obj->set_y(v.GetY());
        pb_obj->set_z(v.GetZ());
    }

    void ToPb(const glm::vec3& v, cs::MFVec3* pb_obj)
    {
        pb_obj->set_x(v.x);
        pb_obj->set_y(v.y);
        pb_obj->set_z(v.z);
    }

    void FromPb(glm::vec3& v, const cs::MFVec3* pb_obj)
    {
        v.x = pb_obj->x();
        v.y = pb_obj->y();
        v.z = pb_obj->z();
    }

    void ToPb(const OverReward& v, cs::MFOverReward* pb_obj)
    {
        pb_obj->mutable_hero()->set_id(v.hero.id);
        pb_obj->mutable_hero()->set_curr_gold(v.hero.curr_gold);
        pb_obj->mutable_hero()->set_obtain_gold(v.hero.obtain_gold);
        pb_obj->mutable_hero()->set_gold_limit(v.hero.gold_limit);

        pb_obj->mutable_weapon1()->set_id(v.weapon1.id);
        pb_obj->mutable_weapon1()->set_curr_gold(v.weapon1.curr_gold);
        pb_obj->mutable_weapon1()->set_obtain_gold(v.weapon1.obtain_gold);
        pb_obj->mutable_weapon1()->set_gold_limit(v.weapon1.gold_limit);

        pb_obj->mutable_weapon2()->set_id(v.weapon2.id);
        pb_obj->mutable_weapon2()->set_curr_gold(v.weapon2.curr_gold);
        pb_obj->mutable_weapon2()->set_obtain_gold(v.weapon2.obtain_gold);
        pb_obj->mutable_weapon2()->set_gold_limit(v.weapon2.gold_limit);
    }

    void ToPb(const HeroStatsPb& v, cs::MFHeroStats* pb_obj)
    {
        pb_obj->set_hero_uniid(v.hero_uniid);
        pb_obj->set_hero_name(v.hero_name);
        pb_obj->set_hero_id(v.hero_id);
        pb_obj->set_reward_ceg(v.reward_ceg);
        pb_obj->set_ceg_uplimit(v.ceg_uplimit);
        pb_obj->set_today_get_ceg(v.today_get_ceg);
    }

    void FromPb(HeroStatsPb& v, const cs::MFHeroStats* pb_obj)
    {
        v.hero_uniid = pb_obj->hero_uniid();
        v.hero_name = pb_obj->hero_name();
        v.hero_id = pb_obj->hero_id();
        v.reward_ceg = pb_obj->reward_ceg();
        v.ceg_uplimit = pb_obj->ceg_uplimit();
        v.today_get_ceg = pb_obj->today_get_ceg();
    }

    void ToPb(const WeaponStatsPb& v, cs::MFWeaponStats* pb_obj)
    {
        pb_obj->set_weapon_uniid(v.weapon_uniid);
        pb_obj->set_weapon_name(v.weapon_name);
        pb_obj->set_weapon_id(v.weapon_id);
        pb_obj->set_reward_ceg(v.reward_ceg);
        pb_obj->set_ceg_uplimit(v.ceg_uplimit);
        pb_obj->set_today_get_ceg(v.today_get_ceg);
    }

    void FromPb(WeaponStatsPb& v, const cs::MFWeaponStats* pb_obj)
    {
        v.weapon_uniid = pb_obj->weapon_uniid();
        v.weapon_name = pb_obj->weapon_name();
        v.weapon_id = pb_obj->weapon_id();
        v.reward_ceg = pb_obj->reward_ceg();
        v.ceg_uplimit = pb_obj->ceg_uplimit();
        v.today_get_ceg = pb_obj->today_get_ceg();
    }

}
