#pragma once

class Player;
class BtEvent;
class BaseAgent;
class EventHandler;
class BtContext : public std::enable_shared_from_this<BtContext>
{
public:

    virtual ~BtContext();
    void AddHandler(std::weak_ptr<Player> target, std::weak_ptr<EventHandler> handler);
    void AddEvent(std::shared_ptr<BtEvent> event);
    bool HasEvent();
    void FireEvent(BaseAgent* agent);

private:
    std::vector<std::shared_ptr<BtEvent>> events_;
    std::vector<std::tuple<std::weak_ptr<Player>, std::weak_ptr<EventHandler>>> handlers_;
};
