#include "precompile.h"

#include "iomgr.h"

static const int IC_Max = 1;

void IoMgr::Init()
{
    for (int i = 0; i < IC_Max; ++i) {
        io_contexts_.push_back(std::vector<std::shared_ptr<asio::io_context>>());
        io_works_.push_back(std::vector<std::shared_ptr<asio::io_context::work>>());
        auto& contexts = io_contexts_.at(i);
        auto& works = io_works_.at(i);
        auto c = std::make_shared<asio::io_context>();
        auto w = std::make_shared<asio::io_context::work>(*c);
        works.push_back(w);
        contexts.push_back(c);
        //new std::thread(&IoMgr::WorkerThreadProc, this, contexts.at(0));
    }
}

void IoMgr::UnInit()
{

}

void IoMgr::Update()
{
    for (auto type_io_contexts : io_contexts_) {
        for (auto io_context : type_io_contexts) {
            io_context->poll();
        }
    }
}

std::shared_ptr<asio::io_context> IoMgr::GetIoContext(int type)
{
    if (type >= 0 && type < io_contexts_.size()) {
        auto& contexts = io_contexts_.at(type);
        if (!contexts.empty()) {
            return contexts.at(rand() % contexts.size());
        }
    }
    return nullptr;
}

void IoMgr::WorkerThreadProc(std::shared_ptr<asio::io_context> io_context)
{
    while (true) {
        io_context->run();
        a8::XPrintf("2222222\n", {});
        io_context->reset();
    }
}
