#pragma once

#include <a8/singleton.h>

#include <asio.hpp>

class IoMgr : public a8::Singleton<IoMgr>
{
private:
    IoMgr() {};
    friend class a8::Singleton<IoMgr>;

public:

    void Init();
    void UnInit();
    void Update();

    std::shared_ptr<asio::io_context> GetIoContext(int type);

 private:
    void WorkerThreadProc(std::shared_ptr<asio::io_context> io_context);

 private:
    std::vector<std::vector<std::shared_ptr<asio::io_context::work>>> io_works_;
    std::vector<std::vector<std::shared_ptr<asio::io_context>>> io_contexts_;
};
