#include "precompile.h"

#include "mt/MetaMgr.h"

#include "app.h"

namespace mt
{

    void MetaMgr::Init()
    {
        if (!f8::IsOnlineEnv()) {
            if (f8::IsTestEnv()) {
                res_path_ = a8::Format("../test_res%d/",
                                      {
                                          f8::App::Instance()->GetInstanceId()
                                      });
            } else {
                res_path_ = a8::Format("../dev_res%d/",
                                      {
                                          f8::App::Instance()->GetInstanceId()
                                      });
            }
        } else {
            res_path_ = "../res/";
        }
        RegMetaTables();
        Load();
    }

    void MetaMgr::RegMetaTables()
    {
    }

    void MetaMgr::Load()
    {
        for (auto& itr : meta_tables) {
            itr->static_pre_init_cb();
            itr->load_cb();
        }
        for (size_t i = 0; i < 3; ++i) {
            for (auto& itr : meta_tables) {
                if (i < itr->init_cbs.size()) {
                    itr->init_cbs.at(i)();
                }
            }
        }
        for (auto& itr : meta_tables) {
            itr->static_post_init_cb();
        }
    }

    void MetaMgr::UnInit()
    {
        for (auto t : meta_tables) {
            t->destory_cb();
        }
        meta_tables.clear();
    }

}
