#include "precompile.h"

#include <iostream>

#include "tracemgr.h"

#ifdef MYDEBUG

#define BOOST_STACKTRACE_USE_ADDR2LINE
#include <boost/stacktrace.hpp>


void TraceMgr::Init(const std::string& filename)
{
    filename_ = filename;
    log_file_ = fopen("backtrace.log", "w");
    if (!log_file_) {
        A8_ABORT();
    }
    PrintBackTrace();
}

void TraceMgr::UnInit()
{
    if (log_file_) {
        fclose(log_file_);
        log_file_ = nullptr;
    }
}

void TraceMgr::Trace(const std::string& hint)
{
}

void TraceMgr::PrintBackTrace()
{
    #if 0
    std::cout << boost::stacktrace::stacktrace();
    #endif
}

#endif
